#include "sim.h"
#include "sVars.h"
#include <iostream>

void sim(struct sVars &);

int main()
{
    sVars Vars;

    // Initial Velocity
    Vars.vx = 0; // [m/s]
    Vars.vy = 0; // [m/s]
    Vars.vz = 0; // [m/s]

    // Initial YPR
    Vars.yaw = 0;   // [rad]
    Vars.pitch = 0; // [rad]
    Vars.roll = 0;  // [rad]

    // Initial YPRdot
    Vars.yawdot = 0;   // [rad/s]
    Vars.pitchdot = 0; // [rad/s]
    Vars.rolldot = 0;  // [rad/s]

    // Servo Limitation
    Vars.maxServo = 0; // [degs]

    // Vehicle Properties
    Vars.m0 = 1.2;                // [kg]
    Vars.vehicleHeight = 0.5318;  // [m]
    Vars.vehicleRadius = 0.05105; // [m]

    // Sim Step Size
    Vars.stepSize = 1; // [ms]

    // Other Properties
    Vars.mp = 0.06;                                             // [kg]
    Vars.mb = Vars.m0 - Vars.mp;                                // [kg]
    Vars.tb = Vars.thrustCurve[25][0] - Vars.thrustCurve[0][0]; // [s]
    Vars.mdot = Vars.mp / Vars.tb;                              // [kg/s]

    sim(Vars);

    std::cout << "Finished";

    return 0;
}